<?php
include('../conn/conn.php');

$subjectName = $_POST['subject_name'];
$teacherName = $_POST['subject_teacher'];

// Check if the subject is already registered 
$stmt = $conn->prepare("SELECT * FROM `tbl_subject` WHERE subject_name = :subject_name AND subject_teacher = :subject_teacher");
$stmt->execute([
    'subject_name' => $subjectName,
    'subject_teacher' => $teacherName,
]);

$existingres = $stmt->fetch(PDO::FETCH_ASSOC);

if (empty($existingres)) {
    // Insert the new customer into the table
    $stmt = $conn->prepare("INSERT INTO `tbl_subject` (`tbl_subject_id`, `subject_name`, `subject_teacher`) 
                           VALUES (NULL, :subject_name, :subject_teacher)");
    $stmt->execute([
        'subject_name' => $subjectName,
        'subject_teacher' => $teacherName,
    ]);
}

header("Location: http://localhost/crud-join-table/");
exit();
