<?php
include 'conn/conn.php';
?>

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>PHP JOINING TABLES</title>

    <!-- Bootstrap CSS CDN -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/css/bootstrap.min.css" integrity="sha384-Gn5384xqQ1aoWXA+058RXPxPg6fy4IWvTNh0E263XmFcJlSAwiGgFAW/dAiS6JXm" crossorigin="anonymous">

    <!-- TI Icon CDN -->
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/ti-icons@0.1.2/css/themify-icons.min.css">

    <!-- CSS -->
    <link rel="stylesheet" href="assets/style.css" class="stylesheet">
</head>
<body>
    <!-- Add Student Modal -->
    <div class="modal fade" id="addStudentModal" tabindex="-1" role="dialog" aria-labelledby="studentModal" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="studentModal">Add Student</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form id="studentID" action="endpoint/add_student.php" method="POST">
                        <input type="text" class="form-control" id="table" name="table" value="tbl_student" hidden>
                        <div class="mb-3" hidden>
                            <label for="studentID" class="form-label">Student ID</label>
                            <input type="text" class="form-control" id="studentID" name="tbl_student_id">
                        </div>
                        <div class="mb-3">
                            <label for="firstName" class="form-label">First Name</label>
                            <input type="text" class="form-control" id="firstName" name="first_name">
                        </div>
                        <div class="mb-3">
                            <label for="lastName" class="form-label">Last Name</label>
                            <input type="text" class="form-control" id="lastName" name="last_name">
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary">Save changes</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <!-- Update Student Modal -->
    <div class="modal fade" id="updateStudentModal" tabindex="-1" role="dialog" aria-labelledby="studentModal" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="studentModal">Update Student</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form id="studentID" action="endpoint/update_student.php" method="POST">
                        <input type="text" class="form-control" id="table" name="table" value="tbl_student" hidden>
                        <div class="mb-3" hidden>
                            <label for="updateStudentID" class="form-label">Student ID</label>
                            <input type="text" class="form-control" id="updateStudentID" name="tbl_student_id">
                        </div>
                        <div class="mb-3">
                            <label for="updateFirstName" class="form-label">First Name</label>
                            <input type="text" class="form-control" id="updateFirstName" name="first_name">
                        </div>
                        <div class="mb-3">
                            <label for="updateLastName" class="form-label">Last Name</label>
                            <input type="text" class="form-control" id="updateLastName" name="last_name">
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary">Save changes</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <!-- Add Subject Modal -->
    <div class="modal fade" id="addSubjectModal" tabindex="-1" role="dialog" aria-labelledby="subjectModal" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="subjectModal">Add Subject</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form id="subject" action="endpoint/add_subject.php" method="POST">
                        <input type="text" class="form-control" id="table" name="table" value="tbl_subject" hidden>
                        <div class="mb-3" hidden>
                            <label for="subjectID" class="form-label">Subject ID</label>
                            <input type="text" class="form-control" id="subjectID" name="tbl_subject_id">
                        </div>
                        <div class="mb-3">
                            <label for="subjectName" class="form-label">Subject Name</label>
                            <input type="text" class="form-control" id="subjectName" name="subject_name">
                        </div>
                        <div class="mb-3">
                            <label for="subjectTeacher" class="form-label">Teacher Name</label>
                            <input type="text" class="form-control" id="subjectTeacher" name="subject_teacher">
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary">Save changes</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <!-- Update Subject Modal -->
    <div class="modal fade" id="updateSubjectModal" tabindex="-1" role="dialog" aria-labelledby="subjectModal" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="subjectModal">Update Subjectl</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form id="subjectID" action="endpoint/update_subject.php" method="POST">
                        <input type="text" class="form-control" id="table" name="table" value="tbl_subject" hidden>
                        <div class="mb-3" hidden>
                            <label for="updateSubjectID" class="form-label">Subject ID</label>
                            <input type="text" class="form-control" id="updateSubjectID" name="tbl_subject_id">
                        </div>
                        <div class="mb-3">
                            <label for="updateSubjectName" class="form-label">Subject Name</label>
                            <input type="text" class="form-control" id="updateSubjectName" name="subject_name">
                        </div>
                        <div class="mb-3">
                            <label for="updateSubjectTeacher" class="form-label">Teacher Name</label>
                            <input type="text" class="form-control" id="updateSubjectTeacher" name="subject_teacher">
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary">Save changes</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>


     <!-- Joining Student and Subject Modal -->
     <div class="modal fade" id="addStatusModal" tabindex="-1" role="dialog" aria-labelledby="statusModal" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="statusModal">Add Subject Status for a Student</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form id="subject" action="endpoint/add_student_status.php" method="POST">
                        <input type="text" class="form-control" id="table" name="table" value="tbl_subject" hidden>
                        <div class="mb-3" hidden>
                            <label for="statusID" class="form-label">Status ID</label>
                            <input type="text" class="form-control" id="statusID" name="tbl_status_id">
                        </div>
                        <div class="mb-3">
                            <label for="studentFullName" class="form-label">Subject Name</label>
                            <?php

                            $stmt = $conn->prepare("SELECT * FROM `tbl_student`");
                            $stmt->execute();
                            $student_result = $stmt->fetchAll();

                            ?>
                            <select class="form-control" name="tbl_student_id" id="" required>
                                <option selected disabled>- select -</option>
                                <?php
                                foreach ($student_result as $student_row) {
                                ?>
                                    <option value="<?php echo $student_row['tbl_student_id']; ?>"><?php echo $student_row['first_name']." ".$student_row['last_name']; ?></option>
                                <?php
                                }
                                ?>
                            </select>
                        </div>
                        <div class="mb-3">
                            <label for="subjectName" class="form-label">Subject Name</label>
                            <?php

                            $stmt = $conn->prepare("SELECT * FROM `tbl_subject`");
                            $stmt->execute();
                            $subject_result = $stmt->fetchAll();

                            ?>
                            <select class="form-control" name="tbl_subject_id" id="subjectName" required>
                                <option selected disabled>- select -</option>
                                <?php
                                foreach ($subject_result as $subject_row) {
                                ?>
                                    <option value="<?php echo $subject_row['tbl_subject_id']; ?>"><?php echo $subject_row['subject_name']." - ".$subject_row['subject_teacher'];  ?></option>
                                <?php
                                }
                                ?>
                            </select>
                        </div>
                        <div class="mb-3">
                            <label for="addStatus" class="form-label">Student Status</label>
                            <input type="text" class="form-control" id="addStatus" name="status" required>
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary">Save changes</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
    <!-- Update Joining Student and Subject Modal -->
    <div class="modal fade" id="updateStatusModal" tabindex="-1" role="dialog" aria-labelledby="statusModal" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="statusModal">Update Subject Status for a Student</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form id="subject" action="endpoint/update_student_status.php" method="POST">
                        <input type="text" class="form-control" id="table" name="table" value="tbl_subject" hidden>
                        <div class="mb-3" hidden>
                            <label for="updateStatusID" class="form-label">Status ID</label>
                            <input type="text" class="form-control" id="updateStatusID" name="tbl_status_id">
                        </div>
                        <div class="mb-3">
                            <label for="updateStudent" class="form-label">Student Name</label>
                            <?php

                            $stmt = $conn->prepare("SELECT * FROM `tbl_student`");
                            $stmt->execute();
                            $student_result = $stmt->fetchAll();

                            ?>
                            <select class="form-control" name="tbl_student_id" id="updateStudent">
                                <option selected disabled>- select -</option>
                                <?php
                                foreach ($student_result as $student_row) {
                                ?>
                                    <option value="<?php echo $student_row['tbl_student_id']; ?>"><?php echo $student_row['first_name']." ".$student_row['last_name']; ?></option>
                                <?php
                                }
                                ?>
                            </select>
                        </div>
                        <div class="mb-3">
                            <label for="updateSubject" class="form-label">Subject Name</label>
                            <?php

                            $stmt = $conn->prepare("SELECT * FROM `tbl_subject`");
                            $stmt->execute();
                            $subject_result = $stmt->fetchAll();

                            ?>
                            <select class="form-control" name="tbl_subject_id" id="updateSubject">
                                <option selected disabled>- select -</option>
                                <?php
                                foreach ($subject_result as $subject_row) {
                                ?>
                                    <option value="<?php echo $subject_row['tbl_subject_id']; ?>"><?php echo $subject_row['subject_name']." - ".$subject_row['subject_teacher'];  ?></option>
                                <?php
                                }
                                ?>
                            </select>
                        </div>
                        <div class="mb-3">
                            <label for="updateStatus" class="form-label">Student Status</label>
                            <input type="text" class="form-control" id="updateStatus" name="status">
                        </div>
                        <div class="modal-footer">
                            <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            <button type="submit" class="btn btn-primary">Save changes</button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>

    <br>

    <h2 class="text-center py-4">PHP CRUD THAT JOINS TWO TABLES</h2>
    <div class="row">

        <!-- Student Area -->
        <div class="col-md-3">
            <div class="card col-md-12">
                <h4 class="text-center">List of Students</h4>
                <!-- Button trigger modal -->
                <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#addStudentModal">
                    Add Student
                </button>

                <br><br>

                <!-- Table -->
                <div class="form">
                    <div class="table-responsive">
                        <table class="table table-hover" id="personTable">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>First Name</th>
                                    <th>Last Name</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>

                                <?php

                                include 'conn/conn.php';

                                $stmt = $conn->prepare("SELECT * FROM `tbl_student`");
                                $stmt->execute();
                                
                                $result = $stmt->fetchAll();

                                foreach ($result as $row) {

                                    $studentID  = $row['tbl_student_id'];
                                    $studentFirstName = $row['first_name'];
                                    $studentLastName = $row['last_name'];

                                ?>

                                    <tr class="">
                                        <td id="studentID-<?= $studentID ?>"><?php echo  $studentID ?> </td>
                                        <td id="studentFirstName-<?= $studentID ?>"><?php echo  $studentFirstName ?></td>
                                        <td id="studentLastName-<?= $studentID ?>"><?php echo  $studentLastName ?></td>
                                        <td>
                                            <div>
                                                <button type="submit" title="Edit" onclick="update_student('<?php echo $studentID ?>')"><i class="ti-pencil-alt"></i></button>
                                                <button type="button" title="Remove" onclick="delete_student('<?php echo $studentID ?>')"><i class="ti-trash"></i></button>
                                            </div>
                                        </td>
                                    </tr>

                                <?php
                                }
                                ?>

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>

        <!-- Subject Area -->
        <div class="col-md-3">
            <div class="card col-md-12">
            <h4 class="text-center">List of Subjects with Teacher</h4>
                <!-- Button trigger modal -->
                <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#addSubjectModal">
                    Add Subject
                </button>

                <br><br>

                <!-- Table -->
                <div class="form">
                    <div class="table-responsive">
                        <table class="table table-hover" id="personTable">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Subject Name</th>
                                    <th>Subject Teacher</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>

                                <?php

                                include 'conn/conn.php';

                                $stmt = $conn->prepare("SELECT * FROM `tbl_subject`");
                                $stmt->execute();
                                
                                $result = $stmt->fetchAll();

                                foreach ($result as $row) {

                                    $subjectID  = $row['tbl_subject_id'];
                                    $subjectName = $row['subject_name'];
                                    $subjectTeacher = $row['subject_teacher'];

                                ?>

                                    <tr class="">
                                        <td id="subjectID-<?= $subjectID ?>"><?php echo  $subjectID ?> </td>
                                        <td id="subjectName-<?= $subjectID ?>"><?php echo  $subjectName ?></td>
                                        <td id="subjectTeacher-<?= $subjectID ?>"><?php echo  $subjectTeacher ?></td>
                                        <td>
                                            <div>
                                                <button type="submit" title="Edit" onclick="update_subject('<?php echo $subjectID ?>')"><i class="ti-pencil-alt"></i></button>
                                                <button type="button" title="Remove" onclick="delete_subject('<?php echo $subjectID ?>')"><i class="ti-trash"></i></button>
                                            </div>
                                        </td>
                                    </tr>

                                <?php
                                }
                                ?>

                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>

        <!-- Student Subject Status Area -->
        <div class="col-md-6">
            <div class="card col-md-12">
            <h4 class="text-center">Student Status in their Subject</h4>
                <!-- Button trigger modal -->
                <button type="button" class="btn btn-primary" data-toggle="modal" data-target="#addStatusModal">
                    Set Status for Student
                </button>

                <br><br>

                <!-- Table -->
                <div class="form">
                    <div class="table-responsive">
                        <table class="table table-hover" id="personTable">
                            <thead>
                                <tr>
                                    <th>ID</th>
                                    <th>Student Name</th>
                                    <th>Subject</th>
                                    <th>Teacher</th>
                                    <th>Status</th>
                                    <th>Action</th>
                                </tr>
                            </thead>
                            <tbody>
                                <?php
                                include 'conn/conn.php';

                                $stmt = $conn->prepare("
                                    SELECT 
                                        `tbl_status`.`tbl_status_id`,
                                        `tbl_student`.`tbl_student_id`,
                                        `tbl_subject`.`tbl_subject_id`,
                                        `tbl_student`.`first_name`,
                                        `tbl_student`.`last_name`,
                                        `tbl_subject`.`subject_name`,
                                        `tbl_subject`.`subject_teacher`,
                                        `tbl_status`.`status`
                                    FROM 
                                        `tbl_status`
                                    LEFT JOIN `tbl_student` ON
                                        `tbl_status`.`tbl_student_id` = `tbl_student`.`tbl_student_id`
                                    LEFT JOIN `tbl_subject` ON
                                        `tbl_status`.`tbl_subject_id` = `tbl_subject`.`tbl_subject_id`
                                ");
                                
                                $stmt->execute(); // This line was missing

                                $result = $stmt->fetchAll();

                                foreach ($result as $row) {
                                    $statusID  = $row['tbl_status_id'];
                                    $statusStudentID  = $row['tbl_student_id'];
                                    $statusSubjectID  = $row['tbl_subject_id'];
                                    $statusStudentFirstName = $row['first_name'];
                                    $statusStudentLastName = $row['last_name'];
                                    $statusSubject = $row['subject_name'];
                                    $statusTeacher = $row['subject_teacher'];
                                    $status = $row['status'];
                                ?>

                                <tr class="">
                                    <td id="statusID-<?= $statusID ?>"><?php echo  $statusID ?> </td>
                                    <td id="statusSubjectID-<?= $statusID ?>" hidden><?php echo  $statusSubjectID ?> </td>
                                    <td id="statusStudentID-<?= $statusID ?>" hidden><?php echo  $statusStudentID ?> </td>
                                    <td id="statusStudentFullName-<?= $statusID ?>"><?php echo  $statusStudentFirstName." ".$statusStudentLastName ?></td>
                                    <td id="statusSubject-<?= $statusID ?>"><?php echo  $statusSubject ?></td>
                                    <td id="statusTeacher-<?= $statusID ?>"><?php echo  $statusTeacher ?></td>
                                    <td id="status-<?= $statusID ?>"><?php echo  $status ?></td>
                                    <td>
                                        <div>
                                            <button type="submit" title="Edit" onclick="update_status('<?php echo $statusID ?>')"><i class="ti-pencil-alt"></i></button>
                                            <button type="button" title="Remove" onclick="delete_status('<?php echo $statusID ?>')"><i class="ti-trash"></i></button>
                                        </div>
                                    </td>
                                </tr>

                                <?php
                                }
                                ?>
                            </tbody>

                        </table>
                    </div>
                </div>
            </div>
        </div>
    </div>
    

    <script>

        // Script for Student

            // update student
            function update_student(id) {
                $("#updateStudentModal").modal("show");

                let updateStudentID = $("#studentID-" + id).text();
                let updateStudentFirstName = $("#studentFirstName-" + id).text();
                let updateStudentLastName = $("#studentLastName-" + id).text();

                $("#updateStudentID").val(updateStudentID);
                $("#updateFirstName").val(updateStudentFirstName);
                $("#updateLastName").val(updateStudentLastName);

            }

            // delete resident data
            function delete_student(id) {

                if (confirm("Do you confirm to delete this student?")) {
                    window.location = "endpoint/delete_student.php?student=" + id
                }
            }



        
        // Script for Subject

            // update subject
            function update_subject(id) {
                $("#updateSubjectModal").modal("show");

                let updateSubjectID = $("#subjectID-" + id).text();
                let updateSubjectName = $("#subjectName-" + id).text();
                let updateSubjectTeacher = $("#subjectTeacher-" + id).text();

                $("#updateSubjectID").val(updateSubjectID);
                $("#updateSubjectName").val(updateSubjectName);
                $("#updateSubjectTeacher").val(updateSubjectTeacher); 

            }

            // delete subject
            function delete_subject(id) {
                
                if (confirm("Do you want to delete this subject?")) {
                    window.location = "endpoint/delete_subject.php?subject=" + id
                }
            }
        
        // Script for Student Status


            // Update status
            function update_status(id) {
                $("#updateStatusModal").modal("show");

                let updateStatusID = $("#statusID-" + id).text();
                let updateStudentFullName = $("#statusStudentFullName-" + id).text();
                $("#updateStudent option").each(function() {
                    let fullName = $(this).text();
                    if (fullName === updateStudentFullName) {
                        $(this).prop("selected", true);
                        return false;
                    }
                });
                let updateSubjectName = $("#statusSubject-" + id).text();
                let updateTeacherName = $("#statusTeacher-" + id).text();
                $("#updateSubject option").each(function() {
                    let optionText = $(this).text();
                    let optionSubject = optionText.split(" - ")[0];
                    let optionTeacher = optionText.split(" - ")[1];

                    if (optionSubject === updateSubjectName && optionTeacher === updateTeacherName) {
                        $(this).prop("selected", true);
                        return false; 
                    }
                });
                let updateStatus = $("#status-" + id).text();

                $("#updateStatusID").val(updateStatusID);
                $("#updateStatus").val(updateStatus);
            }

            // delete status
            function delete_status(id) {

                if (confirm("Do you want to delete this student's status?")) {
                    window.location = "endpoint/delete_student_status.php?status=" + id
                }
            }

            

    </script>
    

    <!-- Bootstrap JS CDN -->
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.12.9/dist/umd/popper.min.js" integrity="sha384-ApNbgh9B+Y1QKtv3Rn7W3mgPxhU9K/ScQsAP7hUibX39j7fakFPskvXusvfa0b4Q" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.0.0/dist/js/bootstrap.min.js" integrity="sha384-JZR6Spejh4U02d8jOt6vLEHfe/JQGiRRSQQxSfFWpi1MquVdAyjUar5+76PVCmYl" crossorigin="anonymous"></script>

</body>  

</html>